#include <stdio.h>
#include <sys/kernel.h>
#include <sys/name.h>

#define ServerName "/MyServer"
#define MSG_SIZE 1024
char msg[MSG_SIZE];

void main()
{
    pid_t pid;
    int id1;  
    
    fprintf(stderr, "Registering server as: MyServer.\n");
    if ((id1 = qnx_name_attach(0, ServerName)) < 0) {
    	perror("qnx_name_attach");
    	exit(1);    
    }
 
	fprintf(stderr, "Server is waiting for messages...\n");
		
	for (;;){
		if ((pid = Receive( 0, &msg, sizeof( msg ) )) < 0) {
			perror("Receive");
			exit(1);
		}
		/*fprintf(stderr, "Received message: %s\n", msg);*/
	
      	Reply( pid, NULL, 0 );
	}
	
	if ((qnx_name_detach(0, id1)) < 0)
		perror("qnx_name_detach");
}