#!/usr/bin/perl -w

if  ($#ARGV != 2) {
  die "usage: tcp_test <hostname> <port> <os>\n";
}

#location of netperf
$os = $ARGV[2];
$os = lc ($os);
if ($os eq "linux")  {
 $executable = "../Linux/netperf";
 $sock_size = "8192";
}
if ($os eq "qnx")  {
 $executable = "../QNX/netperf";
 $sock_size = "8192";
} 
if ($os eq "nt")  {
 $executable = "..\\NT\\netperf.exe";
 $sock_size = "8192";
# $sock_size = "131072";
} 
 
# confidence level
#$confidence1 = "-i5,2";
#$confidence2 = "-I95,5";

# define a TCP test
$test_type = "-tTCP_STREAM";

# maximum time for the test
$max_time = "-l60"; 

#Recv and Send socket size in bytes
$recv_sock_size = "-S$sock_size";
$send_sock_size = "-s$sock_size";
 
# minumum message size
$min_send_size = 1;

#maximum message size
$max_send_size = 131072;

#Set host name
$host = "-H" . $ARGV[0]; 

#Set port num
$port = $ARGV[1];

#every iteration mult the size of the message in this factor
$msg_mult_factor = 2;

for ($size = $min_send_size; $size <= $max_send_size; $size *= $msg_mult_factor){
  $msg_size = "-m" . "$size";
  $port_num = "-p" . $port;
  @args = ($executable,
	   $host, 
	   $port_num,
	   $test_type, 
#	   $confidence1,
#	   $confidence2,
	   $max_time,
	   "--", 
	   $msg_size,
	#   $recv_sock_size,
	#   $send_sock_size,
	   );
  print STDERR "@args \n";
  system(@args);
  #if ($os eq "nt") {
  #  $port++;
  #}
}

# Alt + shift + 8 - remark region.





